import 'dart:async';

import 'package:meta/meta.dart';
import 'package:neon/src/platform/platform.dart';
import 'package:sqflite_common_ffi/sqflite_ffi.dart';
import 'package:sqflite_common_ffi_web/sqflite_ffi_web.dart';
import 'package:universal_html/html.dart' as html;

@immutable
@internal
class WebNeonPlatform implements NeonPlatform {
  const WebNeonPlatform();

  @override
  bool get canUseCamera => false;

  @override
  bool get canUsePushNotifications => false;

  @override
  bool get canUseQuickActions => false;

  @override
  bool get canUseSystemTray => false;

  @override
  bool get canUseWebView => false;

  @override
  bool get canUseWindowManager => false;

  @override
  bool get canUseSharing => true;

  @override
  bool get shouldUseFileDialog => throw UnimplementedError();

  @override
  FutureOr<String>? get userAccessibleAppDataPath => null;

  @override
  String getWindowLocation() => html.window.location.href;

  @override
  FutureOr<void> init() {
    databaseFactory = databaseFactoryFfiWeb;
  }
}
